%Problem 3.2

NL_N = 2;

n = (0:1023)';
x = cos(0.1*pi*n);
w = randn(1024,1);

P = 3;
M = 5;

%Cosine input
y_sys = nlsystem1(x, NL_N);
%white noise input for sys-id
y_w = nlsystem1(w, NL_N);

%estimate model
[H, Vmodel] = vkernels(w, y_w, P, M);

%Compute output of Volterra approximation
y_model = vkernels_o(x, Vmodel);

Q2 = 10*log10(sum(abs(y_model-y_sys).^2)/sum(abs(y_sys).^2))

figure
plot(y_sys)
hold on
plot(y_model, 'r--')
grid on
legend('y_{sys}[n]', 'y_{model}[n]')

